EDIT - bug #8728

Specimen import via BioCASE silently fails
11/27/2019 04:15 PM - Andreas Kohlbecker

Status: New Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.46

Severity: normal Found in Version:

Description

ABCD Specimen import via BioCASE provider silently fails

Logged in as user with GAs: Editor + TAXONNODE.[CREATE,READ,UPDATE,DELETE]{Vascular plants of Greece : Bupleurum
sec. P. Dimopoulos, Th. Raus, E. Bergmeier, Th. Constantinidis, G. latrou, S. Kokkini, A. Strid & D. Tzanoudakis, 2013}

biocase accesspoint: http://ww3.bgbm.org/biocase/pywrapper.cgi?dsa=Herbar

Filter parameters:
e Taxon Name=Bupleurum falcatum*
select all records and import them.
The import stopps at some point with out giving any feedback, afterwards this stacktrace can be found in the log:
'ENTRY org.eclipse.core.jobs 4 0 2019-11-27 16:08:48.259
IMESSAGE This is an unexpected error.

Please contact EDIT Support (EditSupport@bgbm.org) with the error trace below (click on the 'Detai
1s' button).

ISTACK O
java.lang.Exception: login
editor version : 5.11.0
server : ()

schema version
os : Linux 5.0.0-36-generic amdo64
java : 1.8.0_131
org.springframework.transaction.UnexpectedRollbackException: Transaction rolled back because it ha
s been marked as rollback-only

at org.springframework.transaction.support.AbstractPlatformTransactionManager.commit (Abstr
actPlatformTransactionManager. java:724)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTransactionA
fterReturning (TransactionAspectSupport. java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransa
ction(TransactionAspectSupport. java:291)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionIn
terceptor. java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208

at com.sun.proxy.SProxy853.importDataFromStream (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:3
02)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Reflective
MethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation.java:157)
at org.springframework.remoting.support.RemoteInvocationTracelInterceptor.invoke (RemotelInvo
cationTracelnterceptor. java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208

at com.sun.proxy.S$Proxyl069.importDataFromStream(Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemotelInvocation. java:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (DefaultRemo
telInvocationExecutor. java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemotelInvocat
ionBasedExporter.java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResul
t (RemoteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (Httpl
nvokerServiceExporter.java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandler
Adapter.java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet. java:959

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:9
69)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:871)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet.java:845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (Filt
erSecuritylInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Fi
lterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTr
anslationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManage
mentFilter. java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doF
ilter (SecurityContextHolderAwareRequestFilter. java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestC
acheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterI
nternal (BasicAuthenticationFilter.java:213)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilt
er.java:120)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)
at org.springframework.

rFilter.java:64)

at org.springframework.

107)

at org.springframework.

inProxy.java:330)

at org.springframework.

rityContextPersistenceFilter.java:91)
at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha

inProxy.java:330)
at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter
.doFilterInternal (WebAsyncManagerIntegrationFilter.java:53)
at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:

107)

security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWrite
web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
security.web.FilterChainProxyS$VirtualFilterChain.doFilter (FilterCha

security.web.context.SecurityContextPersistenceFilter.doFilter (Secu

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)
at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainProxy. jav

a:213)
at
at
at
at
at
at

org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)
org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)
eu.etaxonomy.taxeditor.Application.start (Application. java:24)

org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppL

auncher. java:134)

at org.eclipse.

ava:104)
at
at
at
at
at
at
at
at
at
at

org.
org.
sun.
sun.
sun.

org.
org.
org.
org.

eclipse.
eclipse.
.NativeMethodAccessorImpl.invokeO (Native Method)

.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

reflect
reflect.

eclipse.
eclipse.
eclipse.
eclipse.

core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLlauncher. j

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)

DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method. invoke (Method. java:498)

equinox.launcher
equinox.launcher
equinox.launcher
equinox.launcher

.Main.

.Main

.Main.

.Main

invokeFramework (Main. java:673)

.basicRun (Main. java:610)

run (Main.java:1519)

.main (Main.java:1492)

History

#1 - 11/27/2019 04:24 PM - Andreas Kohlbecker

this is reproducible

once this error has occurred the taxeditor has to be restarted, otherwise further import attempts seem to be blocked

#2 - 11/27/2019 04:37 PM - Andreas Kohlbecker

- Description updated

#3 - 11/27/2019 04:42 PM - Andreas Kohlbecker

- Tags set to permission

As the import works without problems with the admin user, it seems as if this is a permission problem.

@Katja: 1. do you know the missing permission (Granted Authorities)?

@Katja: 2. The exceptions regarding the insufficient permission must not be caught completely, it is needed that this error is being propagated to the
user in a human friendly form.

#4 - 11/28/2019 08:51 AM - Andreas Kohlbecker

- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 5.12

The problem in one specific case was that the user was not permitted to update a person:

[UPDATE] not permitted for 'kursl' on Person[uuid:43cb913c-£f051-46a7-aece3-044428375806"', toString:'Person#0<43
cb913c-£f051-46a7-aee3-044428375806>"]
eu.etaxonomy.cdm.database.PermissionDeniedException: [UPDATE] not permitted for 'kursl' on Person[uuid:43cb913
c-f051-46a7-aee3-044428375806"', toString:'Person#0<43cb913c-£f051-46a7-aee3-044428375806>"]
It seems as if this is again a problem which arises from a cache modification during the hibernate save operation.
Recently we had a very similar case, has this one been solved?
#5 - 11/28/2019 09:26 AM - Andreas Kohlbecker
Next Problem:
[CREATE] not permitted for 'kursl' on TaxonNode[uuid:79c3deac-eeld-4622-91fa-746be0894161"', toString:'TaxonNod
e#52<79c3deac-eeld-4622-91fa-746be0894161>"']
eu.etaxonomy.cdm.database.PermissionDeniedException: [CREATE] not permitted for 'kursl' on TaxonNode[uuid:79c3
deac-eeld-4622-91fa-746be0894161"', toString:'TaxonNode#52<79c3deac-eeld-4622-91fa-746be0894161>"]
The import
1. two options:
o A: must only allow importing in a new classification, if the user has the general TaxonNode[CREATE] permission
o B: should grant the require TaxonNode[CRUD] permission for the root node of the new created classification
2. should only allow selecting classifications as target if the user has ast least one GrantedAuthority for one TaxonNode in this classification

NOTE: copy the tasks resulting from this comment into a new ticket
#6 - 11/28/2019 09:34 AM - Andreas Miiller
Andreas Kohlbecker wrote:

The problem in one specific case was that the user was not permitted to update a person:

[UPDATE] not permitted for 'kursl' on Person[uuid:43cb913c-£f051-46a7-aee3-044428375806', toString:'Person#

0<43cb913c-£f051-46a7-aee3-044428375806>"]

eu.etaxonomy.cdm.database.PermissionDeniedException: [UPDATE] not permitted for 'kursl' on Person[uuid:43c

b913c-f051-46a7-aee3-044428375806"', toString:'Person#0<43cb913c-f051-46a7-aee3-044428375806>"]

It seems as if this is again a problem which arises from a cache modification during the hibernate save operation.

Recently we had a very similar case, has this one been solved?

The recent problem was a not up-to-date titleCache in E+M after a manual deduplication of persons which lead to not up-to-date titleCaches in the
according teams. This has been "solved" by running the titteCache updater.

#7 - 01/16/2020 12:59 PM - Katja Luther

- Target version changed from Release 5.12 to Release 5.13

#8 - 03/09/2020 04:24 PM - Andreas Miiller

- Target version changed from Release 5.13 to Release 5.14

#9 - 03/31/2020 11:13 AM - Katja Luther

- Target version changed from Release 5.14 to Release 5.15

#10 - 04/22/2020 10:11 AM - Katja Luther

- Target version changed from Release 5.15 to Release 5.18

#11 - 12/04/2020 09:10 AM - Katja Luther

- Target version changed from Release 5.18 to Release 5.19

#12 - 01/27/2021 04:15 PM - Andreas Miiller

- Target version changed from Release 5.19 to Release 5.21

#13 - 03/10/2021 02:46 PM - Andreas Miiller

- Target version changed from Release 5.21 to Release 5.22

#14 - 04/19/2021 05:39 PM - Katja Luther
- Target version changed from Release 5.22 to Release 5.46
